/*
	ASRegistry.r -- Type Declarations for Rez and DeRez
	
	Copyright Apple Computer, Inc. 1993
	All rights reserved.

	3:31 PM Thu, 11 Feb 1993
*/

#ifndef __ASREGISTRY.R__
#define __ASREGISTRY.R__

# define cClassIdentifier	'pcls'
# define cClosure	'clsr'
# define cCoerceKataHiragana	'txkh'
# define cCoerceLowerCase	'txlo'
# define cCoerceOneByteToTwoByte	'txex'
# define cCoerceRemoveDiacriticals	'txdc'
# define cCoerceRemoveHyphens	'txhy'
# define cCoerceRemovePunctuation	'txpc'
# define cCoerceRemoveWhiteSpace	'txws'
# define cCoerceSmallKana	'txsk'
# define cCoerceUpperCase	'txup'
# define cCoerceZenkakuhankaku	'txze'
# define cCoercion	'coec'
# define cConstant	'enum'
# define cEventIdentifier	'evnt'
# define cHandler	'hand'
# define cKeyForm	'keyf'
# define cKeyIdentifier	'kyid'
# define cLinkedList	'llst'
# define cList	'list'
# define cListElement	'celm'
# define cListOrRecord	'lr  '
# define cListOrString	'ls  '
# define cListRecordOrString	'lrs '
# define cMachine	'mach'
# define cNumber	'nmbr'
# define cNumberOrDateTime			'nd  '
# define cNumberDateTimeOrString	'nds '
# define cObjectBeingExamined	'exmn'
# define cPreposition	'prep'
# define cProcedure	'proc'
# define cRawData	'rdat'
# define cReal	'doub'
# define cRecord	'reco'
# define cReference	'obj '
# define cScript	'scpt'
# define cSeconds		'scnd'
# define cSmallReal	'sing'
# define cString	'TEXT'
# define cSymbol	'symb'
# define cUndefined	'undf'
# define cUserIdentifier	'uid '
# define cVector	'vect'
# define cZone	'zone'
# define enumBooleanValues	'boov'
# define enumConsiderations	'cons'
# define enumMiscValues	'misc'
# define kAECase	'case'
# define kAEDiacritic	'diac'
# define kAEExpansion	'expa'
# define kAEFalse	'fals'
# define kAEHyphens	'hyph'
# define kAEKataHiragana	'hika'
# define kAEPunctuation	'punc'
# define kAESmallKana	'skna'
# define kAETrue	'true'
# define kAEWhiteSpace	'whit'
# define kAEZenkakuHankaku	'zkhk'
# define kASAdd	'+   '
# define kASAppleScriptSuite	'ascr'
# define kASComesAfter	'cafr'
# define kASComesBefore	'cbfr'
# define kASComment	'cmnt'
# define kASConcatenate	'ccat'
# define kASConsiderReplies	'rmte'
# define kASContains	'cont'
# define kASCurrentApplication	'cura'
# define kASDivide	'/   '
# define kASEndsWith	'ends'
# define kASEqual	'=   '
# define kASGreaterThan	'>   '
# define kASGreaterThanOrEqual	'>=  '
# define kASLessThan	'<   '
# define kASLessThanOrEqual	'<=  '
# define kASMultiply	'*   '
# define kASNegate	'neg '
# define kASNotEqual	'   '
# define kASPrepositionalSubroutine	'psbr'
# define kASPower	'^   '
# define kASQuotient	'div '
# define kASRemainder	'mod '
# define kASStartsWith	'bgwt'
# define kASSubroutineName	'snam'
# define kASSubtract	'-   '
# define kASTypeNamesSuite	'tpnm'
# define kCleanUpAEUT	'cdut'
# define kDialectBundleResType	'Dbdl'
# define keyAEErrorObject	'erob'
# define keyAETarget	'targ'
# define keyASArg	'arg '
# define keyASPositionalArgs	'parg'
# define keyASPrepositionAbout	'abou'
# define keyASPrepositionAbove	'abve'
# define keyASPrepositionAgainst	'agst'
# define keyASPrepositionApartFrom	'aprt'
# define keyASPrepositionAround	'arnd'
# define keyASPrepositionAsideFrom	'asdf'
# define keyASPrepositionAt	'at  '
# define keyASPrepositionBelow	'belw'
# define keyASPrepositionBeneath	'bnth'
# define keyASPrepositionBeside	'bsid'
# define keyASPrepositionBetween	'btwn'
# define keyASPrepositionBy	'by  '
# define keyASPrepositionFor	'for '
# define keyASPrepositionFrom	'from'
# define keyASPrepositionGiven	'givn'
# define keyASPrepositionIn	'in  '
# define keyASPrepositionInsteadOf	'isto'
# define keyASPrepositionInto	'into'
# define keyASPrepositionOn	'on  '
# define keyASPrepositionOnto	'onto'
# define keyASPrepositionOutOf	'outo'
# define keyASPrepositionOver	'over'
# define keyASPrepositionSince	'snce'
# define keyASPrepositionThrough	'thgh'
# define keyASPrepositionThru	'thru'
# define keyASPrepositionTo	'to  '
# define keyASPrepositionUnder	'undr'
# define keyASPrepositionUntil	'till'
# define keyASPrepositionWith	'with'
# define keyASPrepositionWithout	'wout'
# define keyASUserRecordFields	'usrf'
# define kGetAETE	'gdte'
# define kGetAEUT	'gdut'
# define kUpdateAETE	'udte'
# define kUpdateAEUT	'udut'
# define pASIt	'it  '
# define pASMe	'me  '
# define pASParent	'pare'
# define pASPi	'pi  '
# define pASPrintDepth	'prdp'
# define pASPrintLength	'prln'
# define pASTopLevelScript	'ascr'
# define pASResult	'rslt'
# define pASReturn	'ret '
# define pASSpace	'spac'
# define pASTab	'tab '
# define pInherits	'c@#^'
# define pLength	'leng'
# define pRest	'rest'
# define pReverse	'rvse'
# define typeAETE	'aete'
# define typeAEUT	'aeut'
# define typeUserRecordFields		typeAEList
# define kASErrorEventCode	'err '
# define kASInitializeEventCode	'init'
#define kOSAErrorNumber						'errn'
#define kOSAErrorMessage					'errs'
#define kOSAErrorBriefMessage				'errb'
#define kOSAErrorApp						'erap'
#define kOSAErrorPartialResult				'ptlr'
#define kOSAErrorOffendingObject			'erob'
#define kOSAErrorRange						'erng'
#define kOSAErrorExpectedType		'errt'	// forgotten from OSA.h
#define keyASSubjectAttr			'subj'

// Magic 'returning' parameter:
#define keyASReturning				'Krtn'

// DateTime things:
#define pASWeekday					'wkdy'
#define pASMonth					'mnth'
#define pASDay						'day '
#define pASYear						'year'
#define pASTime						'time'
#define pASDateString				'dstr'
#define pASTimeString				'tstr'

// Months
#define cMonth						pASMonth
#define cJanuary					'jan '
#define cFebruary					'feb '
#define cMarch						'mar '
#define cApril						'apr '
#define cMay						'may '
#define cJune						'jun '
#define cJuly						'jul '
#define cAugust						'aug '
#define cSeptember					'sep '
#define cOctober					'oct '
#define cNovember					'nov '
#define cDecember					'dec '

// Weekdays
#define cWeekday					pASWeekday
#define cSunday						'sun '
#define cMonday						'mon '
#define cTuesday					'tue '
#define cWednesday					'wed '
#define cThursday					'thu '
#define cFriday						'fri '
#define cSaturday					'sat '

// AS 1.1 Globals:
#define pASQuote					'quot'
#define pASSeconds					'secs'
#define pASMinutes					'min '
#define pASHours					'hour'
#define pASDays						'days'
#define pASWeeks					'week'

// Writing Code things:
#define cWritingCodeInfo			'citl'
#define pScriptCode					'pscd'
#define pLangCode					'plcd'

// Magic Tell and End Tell events for logging:
#define kASMagicTellEvent			'tell'
#define kASMagicEndTellEvent		'tend'

#endif __ASREGISTRY.R__
