/*
	SVEditWindow.h
	
	Version 3.0d9
	
	Copyright  SRL Data 1992, 1993
	
	All rights reserved
	
	Produced by : SRL Data
	Originally Developed for UK.DTS
*/

  /*The window and text handling routines for the SVEdit example program*/

	/*
		New for 3.0d2
		
		19-Feb-92 : NH	: Implement PrintWindow
                      Change PageStarts to PageEnds
                      Fix out by one in GetPageEnds
											
		26-Feb-92	: NH	: Put in final printing implementation
										: Fix inThumb scrolling
										: Put in kTextOffset to replace kTextMargin for better borders
										
		28-Feb-92 : NH  : gCurrSection zapped - Incoming AppleEvents make keeping track
		                  via a global very messy. Now check to see when in a section as
											required.
											
		New for 3.0d3
		
		07-Apr-92 : NH  : PrPicFile added to PrintWindow.
		
		 3-Jun-92 : NH  : Fixed bug in DrawPageBreaks (kTextOffset added twice)
		 									Put in progress dialog for printing.
		
		New for 3.0d4
		
		05-Aug-92 : NH  : Param added to newDocument for increment of doc count
		                  DoActivate moved from SVEditMain.c
	*/
	
#ifndef __SVEDITWINDOW__
#define __SVEDITWINDOW__
	
#include <Memory.h>
#include <Types.h>
#include <Quickdraw.h>
#include <Fonts.h>
#include <ToolUtils.h>
#include <Traps.h>
#include "SVEditGlobals.h"
#include "SVEditUtils.h"
#include "SVEditions.h"
#include "SVAppleEvents.h"

pascal DPtr DPtrFromWindowPtr(WindowPtr w);

pascal void MyGrowWindow(WindowPtr w,
                         Point     p);

pascal void DoZoom(WindowPtr w, short c, Point p);

pascal void DoContent(WindowPtr theWindow, EventRecord theEvent);

pascal OSErr DoActivate(WindowPtr theWindow, Boolean   activate);

pascal void DoUpdate(DPtr theDoc);

pascal DPtr NewDocument(Boolean isForOldDoc);

pascal void CloseMyWindow(WindowPtr aWindow);

pascal void ShowSelect(DPtr theDoc);

pascal void AdjustScrollbars(DPtr theDoc, Boolean needsResize);
													 
pascal void GetWinContentRect(WindowPtr theWindow, Rect *r);

pascal void ResizeWindow(DPtr theDoc);

pascal void ResizePageSetupForDocument(DPtr theDoc);

pascal void InvalidateDocument(DPtr theDoc);

pascal void DrawPageExtras(DPtr theDoc);

pascal void PrintWindow(DPtr theDoc, Boolean askUser);

#endif